Foreman - Bug #11079

ovirt 3.5 compute profile edit error: undefined method "text' for nil:NilClass
07/09/2015 09:26 PM - Steve D

Status: Closed
Priority: Normal
Assignee: Tomer Brisker
Category: Compute resources - oVirt
Target version: 1.11.2
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1261868 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3439
Description

Foreman version 1.8.2
Attempting to create a new resource profile on a new ovirt compute resource errors out:

Warning!
undefined method “text' for nil:NilClass

If you feel this is an error with Foreman itself, please open a new issue with Foreman ticketing system, You would probably need to
attach the Full trace and relevant log entries.

NoMethodError

undefined method “text' for nil:NilClass

app/helpers/layout_helper.rb:112:in "block in select_f'

app/helpers/layout_helper.rb:169:in “block (3 levels) in field'

app/helpers/layout_helper.rb:168:in “block (2 levels) in field'

app/helpers/layout_helper.rb:158:in “block in field'

app/helpers/layout_helper.rb:157:in “field'

app/helpers/layout_helper.rb:110:in “select_f'
app/views/compute_resources_vms/form/ovirt/_base.html.erb:10:in
*_app_views_compute_resources_vms_form_ovirt__base_html_erb__ 4409097850897090305_73637740'
app/views/compute_attributes/_compute_form.html.erb:3:in
'_app_views_compute_attributes__compute_form_html_erb_ 1756491331636043450_83732500'
app/views/compute_attributes/_form.html.erb:10:in “block (2 levels) in app_views compute_attributes
_form_html_erb__2970560782621538195_81668060"'
app/views/compute_attributes/_form.html.erb:8:in “block in app_views_compute_attributes
_form_html_erb__2970560782621538195_81668060'

app/helpers/layout_helper.rb:273:in “form_for'

app/views/compute_attributes/_form.html.erb:2:in
"_app_views_compute_attributes__form_html_erb_ 2970560782621538195_81668060'
app/views/compute_attributes/new.html.erb:3:in
*_app_views_compute_attributes_new_html_erb_3418808687226322706_81462020"'
app/controllers/concerns/application_shared.rb:13:in “set_timezone'
app/models/concerns/foreman/thread_session.rb:32:in “clear_thread'
lib/middleware/catch_json_parse_errors.rb:9:in “call'

/var/log/foreman/production.log:

Started GET "/foreman/compute_profiles/7-ovirt_guest_compute/compute_resources/2-ovirt-pcic-uvic-ca/compute_attributes/new"
for 142.104.194.17 at 2015-07-09 18:17:45 -0700

2015-07-09 18:17:45 [I] Processing by ComputeAttributesController#new as */*

2015-07-09 18:17:45[I]] Parameters: {"compute_profile_id"=>"7-ovirt_guest_compute",
"compute_resource_id"=>"2-ovirt-pcic-uvic-ca"}

2015-07-09 18:17:45 [I] Successfully decrypted field for Foreman::Model::Ovirt ovirt.pcic.uvic.ca
2015-07-09 18:17:45 [I] Successfully decrypted field for Foreman::Model::Ovirt ovirt.pcic.uvic.ca
2015-07-09 18:17:45 [I] Rendered compute_resources_vms/form/ovirt/_base.html.erb (132.8ms)
2015-07-09 18:17:45[I] Rendered compute_attributes/_compute_form.html.erb (133.8ms)
2015-07-09 18:17:45[I] Rendered compute_attributes/_form.html.erb (222.7ms)
2015-07-09 18:17:45 [I] Rendered compute_attributes/new.html.erb (226.3ms)

2015-07-09 18:17:45 [W] Operation FAILED: undefined method “text' for nil:NilClass

2015-07-09 18:17:45[I] Rendered common/500.html.erb (5.0ms)

2015-07-09 18:17:45 [I] Completed 500 Internal Server Error in 241ms (Views: 5.6ms | ActiveRecord: 1.3ms)
2015-07-09 18:17:45 [I]

Started GET "/foreman/compute_profiles/7-ovirt_guest_compute/compute_resources/2-ovirt-pcic-uvic-ca/compute_attributes/new"
for 142.104.194.17 at 2015-07-09 18:17:45 -0700

2015-07-09 18:17:45 [I] Processing by ComputeAttributesController#new as */*

2015-07-09 18:17:45 [I] Parameters: {"compute_profile_id"=>"7-ovirt_guest_compute”,
"compute_resource_id"=>"2-ovirt-pcic-uvic-ca"}

2015-07-09 18:17:45 [I] Successfully decrypted field for Foreman::Model::Ovirt ovirt.pcic.uvic.ca

2015-07-09 18:17:45 [I] Successfully decrypted field for Foreman::Model::Ovirt ovirt.pcic.uvic.ca

2015-07-09 18:17:45 [I] Rendered compute_resources_vms/form/ovirt/_base.html.erb (115.9ms)
2015-07-09 18:17:45[]] Rendered compute_attributes/_compute_form.html.erb (116.4ms)

2015-07-09 18:17:45[]] Rendered compute_attributes/_form.html.erb (305.0ms)

2015-07-09 18:17:45 [I] Rendered compute_attributes/new.html.erb (306.5ms)

2015-07-09 18:17:45 [W] Operation FAILED: undefined method “text' for nil:NilClass

2015-07-09 18:17:45[I] Rendered common/500.html.erb (5.0ms)

2015-07-09 18:17:45 [I] Completed 500 Internal Server Error in 317ms (Views: 5.5ms | ActiveRecord: 1.2ms)
2015-07-09 18:21:52 [I]

Related issues:
Related to Foreman - Bug #14090: unable to list ovirt vms (under compute reso... Resolved 03/08/2016

Associated revisions

Revision 0abad579 - 04/28/2016 07:28 AM - Tomer Brisker

Fixes #11079 - Handle oVirt with missing template version name

rbovirt 0.0.37 fixes a bug that causes templates with a missing version
name to raise an exception.

Revision f625e1ec - 04/28/2016 07:31 AM - Dominic Cleal
refs #11079 - require rbovirt 0.0.37

Revision 999c¢759f - 05/16/2016 10:13 AM - Tomer Brisker
Fixes #11079 - Handle oVirt with missing template version name

rbovirt 0.0.37 fixes a bug that causes templates with a missing version
name to raise an exception.

(cherry picked from commit 0abad5795c55f84f2ffc4e744725cce72fc7b241)

History

#1 - 07/09/2015 09:44 PM - Steve D

Also errors when editing a VM listed in foreman hosts after | clicked "Associate VMs" in the ovirt compute resource page:

Warning!
undefined method “text' for nil:NilClass

If you feel this is an error with Foreman itself, please open a new issue with Foreman ticketing system, You would probably need to attach the Full
trace and relevant log entries.

NoMethodError

undefined method “text' for nil:NilClass

app/helpers/layout_helper.rb:112:in “block in select_f'

app/helpers/layout_helper.rb:169:in “block (3 levels) in field'

app/helpers/layout_helper.rb:168:in “block (2 levels) in field'

app/helpers/layout_helper.rb:158:in “block in field'

app/helpers/layout_helper.rb:157:in “field'

app/helpers/layout_helper.rb:110:in “select_f'

app/views/compute_resources_vms/form/ovirt/_base.html.erb:10:in
'_app_views_compute_resources_vms_form_ovirt__base_html_erb_4409097850897090305_73637740'
app/views/hosts/_compute_detail.html.erb:5:in *_app_views_hosts__compute_detail_html_erb__463736123555929698 71892880'
app/views/hosts/_compute.html.erb:5:in “block in app_views_hosts_compute_html_erb__ 3915436782847234139_49077760'
app/views/hosts/_compute.html.erb:1:in *_app_views_hosts__compute_html_erb_ 3915436782847234139_49077760'
app/views/hosts/_unattended.html.erb:2:in *_app_views_hosts__unattended_html_erb__ 71643347212118752_48874320'
app/views/hosts/_form.html.erb:91:in “block (2 levels) in app_views_hosts_form_html_erb__ 4505668517308913666_79729140'
app/helpers/layout_helper.rb:273:in “form_for'
app/views/hosts/_form.html.erb:8:in "block in app_views_hosts_form_html_erb__ 4505668517308913666_79729140'
app/models/taxonomy.rb:61:in “block (2 levels) in as_taxonomy'
app/models/concerns/foreman/thread_session.rb:147:in “as_location'

app/models/taxonomy.rb:60:in “block in as_taxonomy'

app/models/concerns/foreman/thread_session.rb:112:in “as_org'

app/models/taxonomy.rb:59:in “as_taxonomy'

app/views/hosts/_form.html.erb:6:in *_app_views_hosts__form_html_erb_ 4505668517308913666_79729140'
app/views/hosts/edit.html.erb:9:in *_app_views_hosts_edit_html_erb_ 3352575511736684862_81915880"
app/controllers/concerns/application_shared.rb:13:in “set_timezone'
app/models/concerns/foreman/thread_session.rb:32:in “clear_thread'
lib/middleware/catch_json_parse_errors.rb:9:in “call'

#2 - 07/10/2015 03:44 AM - Dominic Cleal

- Category set to Compute resources - oVirt

The dropdown that the error's on is the template list from oVirt, perhaps one has a blank name or something, could be causing an issue.

#3 - 07/11/2015 12:39 AM - Steve D
- File Screenshot from 2015-07-10 21-19-17.png added
- File Screenshot from 2015-07-10 21-35-45.png added

Dominic Cleal wrote:

The dropdown that the error's on is the template list from oVirt, perhaps one has a blank name or something, could be causing an issue.

I've attached a screenshot of the templates on ovirt side, none of them have a null name field.
| also get the error below when creating an image for the ovirt resource:

Warning!
undefined method “text' for nil:NilClass

If you feel this is an error with Foreman itself, please open a new issue with Foreman ticketing system, You would probably need to attach the Full
trace and relevant log entries.

NoMethodError

undefined method “text' for nil:NilClass

app/helpers/images_helper.rb:5:in “any?'

app/helpers/images_helper.rb:5:in “image_field'

app/views/images/form/_ovirt.html.erb:3:in *_app_views_images_form__ovirt_html_erb__ 240184826467530931_82054120'
app/views/images/_form.html.erb:7:in “block in app_views_images_form_htm|_erb__1126843575881072270_80396620'
app/helpers/layout_helper.rb:273:in “form_for'

app/views/images/_form.html.erb:1:in *_app_views_images__form_html_erb__1126843575881072270_80396620'
app/views/images/new.html.erb:3:in *_app_views_images_new_htm|_erb__1996678905612722104_77478080'
app/controllers/concerns/application_shared.rb:13:in “set_timezone'

app/models/concerns/foreman/thread_session.rb:32:in “clear_thread'

lib/middleware/catch_json_parse_errors.rb:9:in “call’

| added a template 'Sub Version Name' and now don't get those errors. Is there a reason this field is mandatory? If you need it for some reason, could
you sub the version# in if the field is null?

Also, when creating images, the 'Image" field dropdown where | can select the ovirt template name isn't very helpful if I'm using sub version templates
in ovirt, it just shows the template name multiple times. It would be handy if this dropdown contained
templatename:version#:subtemplatename:description

#4 - 09/10/2015 06:49 AM - Tomer Brisker
- Bugzilla link set to 1261868

#5 - 03/08/2016 06:58 AM - Marek Hulan

rbovirt issue, PR available at https://github.com/abenari/rbovirt/pull/97

#6 - 03/08/2016 07:15 AM - Marek Hulan

- Related to Bug #14090: unable to list ovirt vms (under compute resource vms tab) added

#7 - 04/15/2016 11:40 AM - Lionel Beard
Hi,

| have the same issue with a template converted from VMWare.
https://github.com/abenari/rbovirt/pull/97

Actually, the issue come from a missing field in oVirt XML file: version_name.
And foreman hangs when parsing the XML file because of this rbovirt file:
rbovirt-0.0.36/lib/ovirt/template_version.rb

which requires version_name field.

The above rbovirt PR doesn't fix this issue.

In my case, | can't add a "Sub Version Name" to my template, and | don't know why... but this is a oVirt issue... :-)

#8 - 04/19/2016 08:25 AM - Tomer Brisker

Looks like this has been fixed for rbovirt 0.0.37: https:/github.com/abenari/rbovirt/commit/9bb6cead2d220bef6ff7f2783a3b61387824e3d5

Lionel - could you try updating rbovirt to confirm?

#9 - 04/19/2016 08:36 AM - Dominic Cleal
- Status changed from New to Closed

- translation missing: en.field_release set to 155

rbovirt 0.0.37 will be available in Debian packages in 1.11.1, and I'll target this at 1.11.2 for the RPMs (also available in nightly until then).

#10 - 04/19/2016 08:40 AM - The Foreman Bot
- Assignee set to Tomer Brisker

- Pull request https://github.com/theforeman/foreman/pull/3439 added

#11 - 04/19/2016 08:49 AM - Dominic Cleal
- Status changed from Closed to Ready For Testing

- translation missing: en.field_release deleted (155)

PR opened instead.

#12 - 04/28/2016 08:02 AM - Anonymous
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 0abad5795c55f84f2ffc4e744725cce72fc7b241.

#13 - 04/28/2016 09:15 AM - Dominic Cleal

- translation missing: en.field_release set to 155

Files

Screenshot from 2015-07-10 21-19-17.png 37 KB 07/11/2015 Steve D

Screenshot from 2015-07-10 21-35-45.png 25.7 KB 07/11/2015 Steve D
https://github.com/abenari/rbovirt/commit/9bb6cead2d220bef6ff7f2783a3b61387824e3d5
